#! /usr/bin/perl

    
    require 5;
    use strict;

    use LWP;
    
    my $browser = LWP::UserAgent->new();
    $browser->env_proxy();
    
    my $verbose = 0;
    my $settings = '';

command:
    for (my $n = 0; $n <= $#ARGV; $n++) {
        my $cmd = $ARGV[$n];
        
        if ($cmd !~ m/^\-/) {
            $cmd = '--get';
            $n--;
        }
        
        if ($cmd =~ m/^\-/) {
            my $opt = $cmd;
            $opt =~ s/\-+//;
#print("$n: command $opt\n");

            
    if ($opt =~ m/^a/) {
        
    if ($n == $#ARGV) {
        die("Argument missing after $cmd command");
    }
    my $arg = $ARGV[++$n];
    
    if ($verbose) {
        printf("%3d: %s %s\n", $n - 1, $cmd, $arg);
    }


        $browser->agent($arg);
        if ($verbose) {
            print("User-Agent set to ", $browser->agent(), "\n");
        }
        next command;
    }

            
    if ($opt =~ m/^g/) {
        
    if ($n == $#ARGV) {
        die("Argument missing after $cmd command");
    }
    my $arg = $ARGV[++$n];
    
    if ($verbose) {
        printf("%3d: %s %s\n", $n - 1, $cmd, $arg);
    }


        
    if ($verbose) {
        my $c = "get";
        $c =~ tr/a-z/A-Z/;
        print("Fetching $arg with $c protocol.\n");
    }
    my $reply;
    
    if ($settings eq '') {
        $reply = $browser->get($arg);
    } else {
        my @pform;
        my $parg = ("get" eq 'post') ? ', \@pform' : '';
        my $s = '$reply = $browser->get($arg' . $settings . ')';
        eval($s);        
    }
    if ($verbose) {
        printf("%s:  Status: %s  Content length: %d\n",
            ($reply->is_success ? "Success" : "Failure"),
            $reply->status_line, length($reply->content));
    }
    next command;

    }

            
    if ($opt =~ m/^hea/) {
        
    if ($n == $#ARGV) {
        die("Argument missing after $cmd command");
    }
    my $arg = $ARGV[++$n];
    
    if ($verbose) {
        printf("%3d: %s %s\n", $n - 1, $cmd, $arg);
    }


        
    if ($verbose) {
        my $c = "head";
        $c =~ tr/a-z/A-Z/;
        print("Fetching $arg with $c protocol.\n");
    }
    my $reply;
    
    if ($settings eq '') {
        $reply = $browser->head($arg);
    } else {
        my @pform;
        my $parg = ("head" eq 'post') ? ', \@pform' : '';
        my $s = '$reply = $browser->head($arg' . $settings . ')';
        eval($s);        
    }
    if ($verbose) {
        printf("%s:  Status: %s  Content length: %d\n",
            ($reply->is_success ? "Success" : "Failure"),
            $reply->status_line, length($reply->content));
    }
    next command;

    }

            
    if ($opt =~ m/^hel/) {
        
    if ($verbose) {
        printf("%3d: %s\n", $n, $cmd);
    }

        print << 'EOD';
Usage: badbot.pl [ commands ]
       Commands:
             --agent name       Set User-Agent to name
             --get url          Retrieve url with GET protocol
             --head url         Retrieve url header with HEAD protocol
             --help             Print this message
             --loop             Loop executing commands
             --post url         Retrieve url with POST protocol
             --set item=value   Add item to request header with specified value
             --verbose          Print verbose debugging information
             --wait n           Sleep for n seconds
        A command which doesn't begin with a "-" is submitted as a
        URL with GET protocol.
Version 0.1, March 2004
EOD
        next command;
    }

            
    if ($opt =~ m/^l/) {
        
    if ($verbose) {
        printf("%3d: %s\n", $n, $cmd);
    }

        if ($n != $#ARGV) {
            die("The --loop command must be the last on the command line");
        }
        $n = -1;
        next command;
    }

            
    if ($opt =~ m/^p/) {
        
    if ($n == $#ARGV) {
        die("Argument missing after $cmd command");
    }
    my $arg = $ARGV[++$n];
    
    if ($verbose) {
        printf("%3d: %s %s\n", $n - 1, $cmd, $arg);
    }


        
    if ($verbose) {
        my $c = "post";
        $c =~ tr/a-z/A-Z/;
        print("Fetching $arg with $c protocol.\n");
    }
    my $reply;
    
    if ($settings eq '') {
        $reply = $browser->post($arg);
    } else {
        my @pform;
        my $parg = ("post" eq 'post') ? ', \@pform' : '';
        my $s = '$reply = $browser->post($arg' . $settings . ')';
        eval($s);        
    }
    if ($verbose) {
        printf("%s:  Status: %s  Content length: %d\n",
            ($reply->is_success ? "Success" : "Failure"),
            $reply->status_line, length($reply->content));
    }
    next command;

    }

            
    if ($opt =~ m/^s/) {
        
    if ($n == $#ARGV) {
        die("Argument missing after $cmd command");
    }
    my $arg = $ARGV[++$n];
    
    if ($verbose) {
        printf("%3d: %s %s\n", $n - 1, $cmd, $arg);
    }


        if ($arg !~ m/^([^=]+)=(.*)$/) {
            die("Syntax error in $cmd option argument");
        }
        $settings .= ", '$1' => '$2'";
#print("Before N = $n ", join(', ', @ARGV), "\n");
        splice(@ARGV, $n - 1, 2);
        $n -= 2;
#print("After N = $n ", join(', ', @ARGV), "\n");
        if ($verbose) {
            print("Request settings: $settings\n");
        }
        next command;
    }

            
    if ($opt =~ m/^w/) {
        
    if ($n == $#ARGV) {
        die("Argument missing after $cmd command");
    }
    my $arg = $ARGV[++$n];
    
    if ($verbose) {
        printf("%3d: %s %s\n", $n - 1, $cmd, $arg);
    }


        
        if ($arg !~ m/^\d+$/) {
            die("Argument to $cmd must be numeric.\n");
        }
        if ($verbose) {
            print("Waiting $arg seconds.\n");
        }
        sleep($arg);
        next command;
    }

            
    if ($opt =~ m/^v/) {
        $verbose = 1;
        
    if ($verbose) {
        printf("%3d: %s\n", $n, $cmd);
    }

        next command;
    }

            
            die("Unknown command $cmd");
        }
    }
        
